VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5550
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5535
   LinkTopic       =   "Form1"
   ScaleHeight     =   5550
   ScaleWidth      =   5535
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      BackColor       =   &H00404040&
      Height          =   4095
      Left            =   0
      ScaleHeight     =   4035
      ScaleWidth      =   4515
      TabIndex        =   1
      Top             =   600
      Width           =   4575
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' See "Barnsley's Fern" by Eric W. Weisstein From MathWorld--A Wolfram Web Resource.
' http://mathworld.wolfram.com/BarnsleysFern.html
Option Explicit

Private m_Prob(0 To 3) As Single
Private m_Func(0 To 3, 0 To 1, 0 To 1) As Single
Private m_Plus(0 To 3, 0 To 1) As Single
Private m_Clr(0 To 3) As OLE_COLOR

Private Sub cmdGo_Click()
Dim i As Long
Dim j As Integer
Dim num As Single
Dim x As Single
Dim y As Single
Dim x1 As Single
Dim y1 As Single
Dim func_num As Integer
Dim clr As OLE_COLOR

    If cmdGo.Caption = "Go" Then
        picCanvas.Cls
        cmdGo.Caption = "Stop"
        Screen.MousePointer = vbHourglass
        DoEvents

        x = 1
        y = 1
        For i = 1 To 100000
            If i Mod 1000 = 0 Then DoEvents
            If cmdGo.Caption = "Go" Then Exit For

            num = Rnd
            For j = 0 To 3
                num = num - m_Prob(j)
                If num <= 0 Then
                    func_num = j
                    clr = m_Clr(j)
                    Exit For
                End If
            Next j

            x1 = x * m_Func(func_num, 0, 0) + y * m_Func(func_num, 0, 1) + m_Plus(func_num, 0)
            y1 = x * m_Func(func_num, 1, 0) + y * m_Func(func_num, 1, 1) + m_Plus(func_num, 1)
            x = x1
            y = y1
            picCanvas.PSet (x, y), clr
        Next i
        cmdGo.Caption = "Go"

        Screen.MousePointer = vbDefault
    Else
        cmdGo.Caption = "Go"
    End If
End Sub
Private Sub Form_Load()
    Randomize
    picCanvas.AutoRedraw = True
    picCanvas.Scale (-4, 10)-(4, 0)

    ' Initialize the fern functions.
    m_Clr(0) = vbRed
    m_Prob(0) = 0.01
    m_Func(0, 0, 0) = 0
    m_Func(0, 0, 1) = 0
    m_Func(0, 1, 0) = 0
    m_Func(0, 1, 1) = 0.16
    m_Plus(0, 0) = 0
    m_Plus(0, 1) = 0

    m_Clr(1) = vbGreen
    m_Prob(1) = 0.85
    m_Func(1, 0, 0) = 0.85
    m_Func(1, 0, 1) = 0.04
    m_Func(1, 1, 0) = -0.04
    m_Func(1, 1, 1) = 0.85
    m_Plus(1, 0) = 0
    m_Plus(1, 1) = 1.6

    m_Clr(2) = vbBlue
    m_Prob(2) = 0.08
    m_Func(2, 0, 0) = 0.2
    m_Func(2, 0, 1) = -0.26
    m_Func(2, 0, 1) = -0.23
    m_Func(2, 1, 1) = 0.22
    m_Plus(2, 0) = 0
    m_Plus(2, 1) = 1.6

    m_Clr(3) = vbWhite
    m_Prob(3) = 0.06
    m_Func(3, 0, 0) = -0.15
    m_Func(3, 0, 1) = 0.28
    m_Func(3, 1, 0) = 0.26
    m_Func(3, 1, 1) = 0.24
    m_Plus(3, 0) = 0
    m_Plus(3, 1) = 0.44

    m_Clr(0) = vbGreen
    m_Clr(1) = vbGreen
    m_Clr(2) = vbGreen
    m_Clr(3) = vbGreen
End Sub

Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 120 Then hgt = 120
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt
    picCanvas.Scale (-4, 10.1)-(4, -0.1)
End Sub


Private Sub Form_Unload(Cancel As Integer)
    End
End Sub


